package dk.nsp.idsas.dao;

import dk.nsp.idsas.util.WhitelistType;
import org.springframework.dao.EmptyResultDataAccessException;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;

import javax.sql.DataSource;
import java.util.HashMap;

public class WhitelistDao {
    private final NamedParameterJdbcTemplate jdbcTemplate;

    public WhitelistDao(DataSource dataSource) {
        jdbcTemplate = new NamedParameterJdbcTemplate(dataSource);
    }

    public boolean isWhitelisted(String cvr, WhitelistType type) {
        String query = "select 1 from whitelist where cvr = :cvr and type = :type";
        HashMap<String, String> parameters = new HashMap<>();
        parameters.put("cvr", cvr);
        parameters.put("type", type.name());
        try {
            jdbcTemplate.queryForObject(query, parameters, Boolean.class);
            return true;
        } catch (EmptyResultDataAccessException e) {
            return false;
        }
    }
}
